---
title: Home
hide_toc: true
---

![PyPI - Version](https://img.shields.io/pypi/v/CAVEclient)
[![build status](https://github.com/CAVEconnectome/CAVEclient/actions/workflows/daily.yml/badge.svg)](https://github.com/CAVEconnectome/CAVEclient/actions/workflows/daily.yml) [![Downloads](https://static.pepy.tech/badge/caveclient)](https://pepy.tech/project/caveclient)

CAVE is short for Connectome Annotation Versioning Engine. CAVE is a set of microservices
that provide a framework for storing and versioning connectomics data and large sets of
dynamic annotations, metadata, and segmentations. This repository supplies client-side
code to easily interact with the microservices in CAVE.

## Documentation Layout

To learn how to install `caveclient`, visit [Installation](./installation.md).

To see hands-on examples of using `caveclient` in a notebook, visit the [Tutorials](./tutorials/index.md).

To see API reference documentation for interacting with a `caveclient.CAVEclient` object,
visit the [Client API](./api/index.md).

To see a glossary of terms used in the documentation, visit the [Glossary (work in progress)](./glossary.md).

For information about how to contribute to the documentation or the package, visit the [Contributing](./contributing.md) page.
Feedback on the documentation is welcome! Please [open an issue](https://github.com/{{ config.repo_name }}/issues/new) or
use the "Edit this page" button at the top right of any page to suggest changes.

To read a full description of the Connectome Annotation Versioning Engine, including a description of the various services please [read this paper](https://www.biorxiv.org/content/10.1101/2023.07.26.550598v1).
